#!/usr/bin/env python

from string import *
from math import *
from cmath import *
# Note: math and cmath have to be imported before Numeric
from Numeric import *
from gist import *


def dataread(filename):
    file_descriptor = open(filename)
    lines = file_descriptor.readlines()
    file_descriptor.close()
    freqs = zeros(len(lines), Float)
    re_s11s = zeros(len(lines), Float)
    im_s11s = zeros(len(lines), Float)
    index = 0
    for line in lines:
	tokens = split(line, ',')
	freqs[index] = atof(tokens[0])
	re_s11s[index] = atof(tokens[1])
	im_s11s[index] = atof(tokens[2])
	index = index + 1
    return freqs, re_s11s, im_s11s

def paws():
    i = raw_input("PAWS")
    return
    
def argument(z):
    return arctan(z.imaginary/z.real)

def norm(x, y):
    return sqrt(x*x+y*y)

def z_input(circuit, freq):
    head = circuit[0]
    if head[1] == 's': v, i = 0.0, 1.0
    else: v, i = 1.0, 0.0
    omega = 2*pi*freq
    for element in circuit:
        if element[1] == 's':
            if element[0] == 'L': z = 1j*omega*element[2]
            elif element[0] == 'R': z = element[2]
            elif element[0] == 'C': z = -1j/(omega*element[2])
            elif element[0] == 'S': z = 0
            elif element[0] == 'A': z = z_input(element[2], freq)
            v = i*z+v
        elif element[1] == 'p':
            if element[0] == 'L': y = -1j/(omega*element[2])
            elif element[0] == 'R': y = 1.0/element[2]
            elif element[0] == 'C': y = 1j*omega*element[2]
            elif element[0] == 'O': y = 0
            elif element[0] == 'A': y = 1.0/z_input(element[2], freq)
            i = v*y+i
        elif element[1] == 't':
            z = element[2]
            x = (element[3]*sqrt(freq/130e6)+1j*omega/element[4])*element[5]
            a, b = cosh(x), sinh(x)
            v, i = a*v+z*b*i, b*v/z+a*i
        else:
            print "ERROR"
    return v/i

if __name__ == '__main__':

    import sys

    if len(sys.argv) != 2:
	print "Usage: lire fichier"
    else:
	freqs, re_s11s, im_s11s = dataread(sys.argv[1])
	window(0, dpi = 100, legends = 0, style = "boxed.gs")
	plg(im_s11s, re_s11s, marks = 0)
	limits(-1.0, 1.0, -1.0, 1.0)
	#    plg(im_s11s, freqs, type = "dot", marks = 0)
	paws()
	winkill(0)
	window(0, dpi = 100, legends = 0, style = "boxed.gs")
	plg(re_s11s, freqs, marks = 0)
	plg(im_s11s, freqs, marks = 0)
	paws() 
	winkill(0)
	window(0, dpi = 100, legends = 0, style = "boxed.gs")
	plg(re_s11s, freqs, marks = 0)
	plg(im_s11s, freqs, marks = 0)
	paws()






